/****************************************************************************
*  Copyright (C) 1996 by Leo Khramov
*  email:     leo@pop.convey.ru
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
 ****************************************************************************/
#include "pager.h"

void drawh(Window w,GC gcw,int x,int y,int l,int h,int fl=0)
{
   XSetForeground(disp,gcw,keyscol[2]);
   XDrawLine(disp,w,gcw,x,y+h,x,y+5);
   XDrawLine(disp,w,gcw,x,y+5,x+5,y);
   XDrawLine(disp,w,gcw,x+5,y,x+l-5,y);
   if(fl)
   {
   XDrawLine(disp,w,gcw,x+1,y+h+1,x+1,y+5);
   XDrawLine(disp,w,gcw,x+1,y+5,x+5,y+1);
   XDrawLine(disp,w,gcw,x+5,y+1,x+l-5,y+1);
   }
   XSetForeground(disp,gcw,keyscol[0]);
   XDrawLine(disp,w,gcw,x+l-5,y,x+l,y+5);
   XDrawLine(disp,w,gcw,x+l,y+5,x+l,y+h);
   if(fl)
   {
   XDrawLine(disp,w,gcw,x+l-5,y+1,x+l-1,y+5);
   XDrawLine(disp,w,gcw,x+l-1,y+5,x+l-1,y+h+1);
   XSetForeground(disp,gcw,cols[0]);
   XDrawLine(disp,w,gcw,x+l-3,y+1,x+l+1,y+5);
   XDrawLine(disp,w,gcw,x+l+1,y+6,x+l+1,y+h);
   }
}

///////////////////////////////////Pager class///////////////////////////////
void Pager::init(Window ipar)
{
 int tw;
 parent=ipar;
 w=XCreateSimpleWindow(disp,parent,x,y,l,h,0,0,keyscol[1]);
 gcv.background=keyscol[1];
 gcv.font=fontstr->fid;
 gcw=XCreateGC(disp,w,GCBackground | GCFont,&gcv);
 XSelectInput(disp,w,ExposureMask | ButtonPressMask | ButtonReleaseMask);
 ty=fontstr->max_bounds.ascent-fontstr->max_bounds.descent;
 prflg=0;
}

void Pager::expose()
{
 int i,itl,itx;
   XClearWindow(disp,w);
   XSetForeground(disp,gcw,keyscol[2]);
//   XDrawLine(disp,w,gcw,0,0,l,0);
   XDrawLine(disp,w,gcw,0,25,0,h);
//   XDrawLine(disp,w,gcw,1,1,l-1,1);
   XDrawLine(disp,w,gcw,1,25,1,h-1);
   XDrawLine(disp,w,gcw,0,25,cur*phl,25);
   XDrawLine(disp,w,gcw,(cur+1)*phl-2,25,l,25);
   XSetForeground(disp,gcw,keyscol[0]);
   XDrawLine(disp,w,gcw,0,h-1,l,h-1);
   XDrawLine(disp,w,gcw,l-1,25,l-1,h);
   XDrawLine(disp,w,gcw,1,h-2,l-1,h-2);
   XDrawLine(disp,w,gcw,l-2,25,l-2,h-1);
   for(i=0;i<max;i++)
   if(i==cur)
   {
    drawh(w,gcw,cur*phl,0,phl-2,24,1);
    if(pname[i])
    {
    XSetForeground(disp,gcw,cols[1]);
    itl=strlen(pname[i]);
    itx=XTextWidth(fontstr,pname[i],itl);
    XDrawString(disp,w,gcw,i*phl+phl/2-itx/2,20,pname[i],itl);
    }
   }
   else
   {
    drawh(w,gcw,i*phl,1,phl-1,23);
    if(pname[i])
    {
    XSetForeground(disp,gcw,cols[0]);
    itl=strlen(pname[i]);
    itx=XTextWidth(fontstr,pname[i],itl);
    XDrawString(disp,w,gcw,i*phl+phl/2-itx/2,20,pname[i],itl);
    }
   }
   if(o[cur]!=NULL)
   {
    for(i=0;i<omax[cur];i++)
     if(o[cur][i]->w==w) o[cur][i]->click();
   }
/*   if(ffl && o[cur]!=NULL)
   {
   if(o[cur][0]) if(o[cur][0]->foc==0) 
        XSetInputFocus(disp,o[cur][0]->w,RevertToNone,CurrentTime);
   ffl=0;
   }*/
   XFlush(disp);
 while(XCheckWindowEvent(disp,w,ExposureMask,&ev));
   
}

void Pager::hidepage()
{
 if(o[cur])
 {
  for(int i=0;i<omax[cur];i++)
   if(o[cur][i]) o[cur][i]->hide();
  }
}

void Pager::showpage()
{
 if(o[cur])
 {
  for(int i=0;i<omax[cur];i++)
   if(o[cur][i]) o[cur][i]->show();
  }
}

void Pager::show()
{
 Gui::show();
 showpage();
}

void Pager::click()
{
 int cx;
 if(ev.xany.window==w)
 {
  switch(ev.type)
  {
  case Expose: expose();break;
  case ButtonPress: 
   if(ev.xbutton.y<25)
   {
    cx=ev.xbutton.x/phl;
    if(cx!=cur && cx<max)
    {
     hidepage();
     cur=cx;
     showpage();
//     ev.type=Expose;
//     expose();
     }
    };
    break;
  case ButtonRelease:
   break;
  };
 }
}

void Pager::setpage(int p)
{
//////////////////////////Add switching when Pager is already shown/////////

 cur=p;
 }
 
////////////////////////////////End of file/////////////////////////////////////////
